import{s as Xe,n as Ze,o as et}from"../chunks/scheduler.db6b1edd.js";import{S as tt,i as rt,g as a,s as o,u as me,A as st,h as n,f as t,c as l,j as p,v as we,y as u,k as i,o as h,a as s,w as be,d as xe,t as _e,x as ge}from"../chunks/index.34de4e79.js";import{I as Ce}from"../chunks/IconCopyLink.f72c3de0.js";function at(Te){let c,B,U,G,d,w,z,g,ye,I,qe="Server infrastructure",K,C,je='The <a href="https://github.com/huggingface/datasets-server" rel="nofollow">Datasets Server</a> has two main components that work together to return queries about a dataset instantly:',Q,y,Ae="<li>a user-facing web API for exploring and returning information about a dataset</li> <li>a server runs the queries ahead of time and caches them in a database</li>",V,k,He="While most of the documentation is focused on the web API, the server is crucial because it performs all the time-consuming preprocessing and stores the results so the web API can retrieve and serve them to the user. This saves a user time because instead of generating the response every time it gets requested, Datasets Server can return the preprocessed results instantly from the cache.",X,$,Se="There are three elements that keep the server running: the job queue, workers, and the cache.",Z,f,b,O,P,ke,W,Ee="Job queue",ee,T,Le="The job queue is a list of jobs stored in a Mongo database that should be completed by the workers. The jobs are practically identical to the endpoints the user uses; only the server runs the jobs ahead of time, and the user gets the results when they use the endpoint.",te,q,Me="There are three jobs:",re,j,Ne='<li><code>/splits</code> corresponds to the <code>/splits</code> endpoint. It refreshes a dataset and then returns that dataset’s splits and configurations. For every split in the dataset, it’ll create a new job.</li> <li><code>/first-rows</code> corresponds to the <code>/first-rows</code> endpoint. It gets the first 100 rows and columns of a dataset split.</li> <li><code>/parquet</code> corresponds to the <code>/parquet</code> endpoint. It downloads the whole dataset, converts it to <a href="https://parquet.apache.org/" rel="nofollow">parquet</a> and publishes the parquet files to the Hub.</li>',se,A,Ie="You might’ve noticed the <code>/rows</code> and <code>/search</code> endpoints don’t have a job in the queue. The responses from these endpoints are generated on demand.",ae,v,x,F,H,$e,D,We="Workers",ne,S,De="Workers are responsible for executing the jobs in the queue. They complete the actual preprocessing requests, such as getting a list of splits and configurations. The workers can be controlled by configurable environment variables, like the minimum or the maximum number of rows returned by a worker or the maximum number of jobs to start per dataset user or organization.",oe,E,Je='Take a look at the <a href="https://github.com/huggingface/datasets-server/tree/main/services/worker#configuration" rel="nofollow">workers configuration</a> for a complete list of the environment variables if you’re interested in learning more.',le,m,_,R,L,Pe,J,Ue="Cache",ie,M,ze="Once the workers complete a job, the results are stored - or <em>cached</em> - in a Mongo database. When a user makes a request with an endpoint like <code>/first-rows</code>, Datasets Server retrieves the preprocessed response from the cache, and serves it to the user. This eliminates the time a user would’ve waited if the server hadn’t already completed the job and stored the response.",he,N,Oe="As a result, users can get their requested information about a dataset (even large ones) nearly instantaneously!",ue,Y,pe;return g=new Ce({}),P=new Ce({}),H=new Ce({}),L=new Ce({}),{c(){c=a("meta"),B=o(),U=a("p"),G=o(),d=a("h1"),w=a("a"),z=a("span"),me(g.$$.fragment),ye=o(),I=a("span"),I.textContent=qe,K=o(),C=a("p"),C.innerHTML=je,Q=o(),y=a("ul"),y.innerHTML=Ae,V=o(),k=a("p"),k.textContent=He,X=o(),$=a("p"),$.textContent=Se,Z=o(),f=a("h2"),b=a("a"),O=a("span"),me(P.$$.fragment),ke=o(),W=a("span"),W.textContent=Ee,ee=o(),T=a("p"),T.textContent=Le,te=o(),q=a("p"),q.textContent=Me,re=o(),j=a("ul"),j.innerHTML=Ne,se=o(),A=a("p"),A.innerHTML=Ie,ae=o(),v=a("h2"),x=a("a"),F=a("span"),me(H.$$.fragment),$e=o(),D=a("span"),D.textContent=We,ne=o(),S=a("p"),S.textContent=De,oe=o(),E=a("p"),E.innerHTML=Je,le=o(),m=a("h2"),_=a("a"),R=a("span"),me(L.$$.fragment),Pe=o(),J=a("span"),J.textContent=Ue,ie=o(),M=a("p"),M.innerHTML=ze,he=o(),N=a("p"),N.textContent=Oe,ue=o(),Y=a("p"),this.h()},l(e){const r=st("svelte-1phssyn",document.head);c=n(r,"META",{name:!0,content:!0}),r.forEach(t),B=l(e),U=n(e,"P",{}),p(U).forEach(t),G=l(e),d=n(e,"H1",{class:!0});var ce=p(d);w=n(ce,"A",{id:!0,class:!0,href:!0});var Fe=p(w);z=n(Fe,"SPAN",{});var Re=p(z);we(g.$$.fragment,Re),Re.forEach(t),Fe.forEach(t),ye=l(ce),I=n(ce,"SPAN",{"data-svelte-h":!0}),u(I)!=="svelte-5l7ldd"&&(I.textContent=qe),ce.forEach(t),K=l(e),C=n(e,"P",{"data-svelte-h":!0}),u(C)!=="svelte-is33n6"&&(C.innerHTML=je),Q=l(e),y=n(e,"UL",{"data-svelte-h":!0}),u(y)!=="svelte-12qbi16"&&(y.innerHTML=Ae),V=l(e),k=n(e,"P",{"data-svelte-h":!0}),u(k)!=="svelte-tuxeb9"&&(k.textContent=He),X=l(e),$=n(e,"P",{"data-svelte-h":!0}),u($)!=="svelte-19jmf8q"&&($.textContent=Se),Z=l(e),f=n(e,"H2",{class:!0});var de=p(f);b=n(de,"A",{id:!0,class:!0,href:!0});var Ye=p(b);O=n(Ye,"SPAN",{});var Be=p(O);we(P.$$.fragment,Be),Be.forEach(t),Ye.forEach(t),ke=l(de),W=n(de,"SPAN",{"data-svelte-h":!0}),u(W)!=="svelte-1p6i913"&&(W.textContent=Ee),de.forEach(t),ee=l(e),T=n(e,"P",{"data-svelte-h":!0}),u(T)!=="svelte-1r0ezeb"&&(T.textContent=Le),te=l(e),q=n(e,"P",{"data-svelte-h":!0}),u(q)!=="svelte-wyypiy"&&(q.textContent=Me),re=l(e),j=n(e,"UL",{"data-svelte-h":!0}),u(j)!=="svelte-n6lfh"&&(j.innerHTML=Ne),se=l(e),A=n(e,"P",{"data-svelte-h":!0}),u(A)!=="svelte-1e44dmt"&&(A.innerHTML=Ie),ae=l(e),v=n(e,"H2",{class:!0});var fe=p(v);x=n(fe,"A",{id:!0,class:!0,href:!0});var Ge=p(x);F=n(Ge,"SPAN",{});var Ke=p(F);we(H.$$.fragment,Ke),Ke.forEach(t),Ge.forEach(t),$e=l(fe),D=n(fe,"SPAN",{"data-svelte-h":!0}),u(D)!=="svelte-s915b0"&&(D.textContent=We),fe.forEach(t),ne=l(e),S=n(e,"P",{"data-svelte-h":!0}),u(S)!=="svelte-7k57hi"&&(S.textContent=De),oe=l(e),E=n(e,"P",{"data-svelte-h":!0}),u(E)!=="svelte-1jj7ypx"&&(E.innerHTML=Je),le=l(e),m=n(e,"H2",{class:!0});var ve=p(m);_=n(ve,"A",{id:!0,class:!0,href:!0});var Qe=p(_);R=n(Qe,"SPAN",{});var Ve=p(R);we(L.$$.fragment,Ve),Ve.forEach(t),Qe.forEach(t),Pe=l(ve),J=n(ve,"SPAN",{"data-svelte-h":!0}),u(J)!=="svelte-14p6x6h"&&(J.textContent=Ue),ve.forEach(t),ie=l(e),M=n(e,"P",{"data-svelte-h":!0}),u(M)!=="svelte-vx3101"&&(M.innerHTML=ze),he=l(e),N=n(e,"P",{"data-svelte-h":!0}),u(N)!=="svelte-l44lf6"&&(N.textContent=Oe),ue=l(e),Y=n(e,"P",{}),p(Y).forEach(t),this.h()},h(){i(c,"name","hf:doc:metadata"),i(c,"content",JSON.stringify(nt)),i(w,"id","server-infrastructure"),i(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(w,"href","#server-infrastructure"),i(d,"class","relative group"),i(b,"id","job-queue"),i(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(b,"href","#job-queue"),i(f,"class","relative group"),i(x,"id","workers"),i(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(x,"href","#workers"),i(v,"class","relative group"),i(_,"id","cache"),i(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(_,"href","#cache"),i(m,"class","relative group")},m(e,r){h(document.head,c),s(e,B,r),s(e,U,r),s(e,G,r),s(e,d,r),h(d,w),h(w,z),be(g,z,null),h(d,ye),h(d,I),s(e,K,r),s(e,C,r),s(e,Q,r),s(e,y,r),s(e,V,r),s(e,k,r),s(e,X,r),s(e,$,r),s(e,Z,r),s(e,f,r),h(f,b),h(b,O),be(P,O,null),h(f,ke),h(f,W),s(e,ee,r),s(e,T,r),s(e,te,r),s(e,q,r),s(e,re,r),s(e,j,r),s(e,se,r),s(e,A,r),s(e,ae,r),s(e,v,r),h(v,x),h(x,F),be(H,F,null),h(v,$e),h(v,D),s(e,ne,r),s(e,S,r),s(e,oe,r),s(e,E,r),s(e,le,r),s(e,m,r),h(m,_),h(_,R),be(L,R,null),h(m,Pe),h(m,J),s(e,ie,r),s(e,M,r),s(e,he,r),s(e,N,r),s(e,ue,r),s(e,Y,r),pe=!0},p:Ze,i(e){pe||(xe(g.$$.fragment,e),xe(P.$$.fragment,e),xe(H.$$.fragment,e),xe(L.$$.fragment,e),pe=!0)},o(e){_e(g.$$.fragment,e),_e(P.$$.fragment,e),_e(H.$$.fragment,e),_e(L.$$.fragment,e),pe=!1},d(e){e&&(t(B),t(U),t(G),t(d),t(K),t(C),t(Q),t(y),t(V),t(k),t(X),t($),t(Z),t(f),t(ee),t(T),t(te),t(q),t(re),t(j),t(se),t(A),t(ae),t(v),t(ne),t(S),t(oe),t(E),t(le),t(m),t(ie),t(M),t(he),t(N),t(ue),t(Y)),t(c),ge(g),ge(P),ge(H),ge(L)}}}const nt={local:"server-infrastructure",sections:[{local:"job-queue",title:"Job queue"},{local:"workers",title:"Workers"},{local:"cache",title:"Cache"}],title:"Server infrastructure"};function ot(Te){return et(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ut extends tt{constructor(c){super(),rt(this,c,ot,at,Xe,{})}}export{ut as component};
