import{s as Le,n as Me,o as Pe}from"../chunks/scheduler.db6b1edd.js";import{S as Te,i as He,g as i,s as o,u as ae,A as Se,h as s,f as t,c as l,j as c,v as ne,y as d,k as r,o as h,a as n,w as ie,d as se,t as oe,x as le}from"../chunks/index.34de4e79.js";import{I as re}from"../chunks/IconCopyLink.f72c3de0.js";function Ee(he){let u,I,E,U,f,g,A,_,Z,T,ce="Splits and configurations",q,y,de="Machine learning datasets are commonly organized in <em>splits</em> and they may also have <em>configurations</em>. These internal structures provide the scaffolding for building out a dataset, and determines how a dataset should be split and organized. Understanding a dataset’s structure can help you create your own dataset, and know which subset of data you should use when during model training and evaluation.",F,x,ue='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/split-configs-server.gif" alt="split-configs-server"/>',O,p,v,z,$,ee,H,fe="Splits",J,b,pe="Every processed and cleaned dataset contains <em>splits</em>, specific subsets of data reserved for specific needs. The most common splits are:",R,C,me="<li><code>train</code>: data used to train a model; this data is exposed to the model</li> <li><code>validation</code>: data reserved for evaluation and improving model hyperparameters; this data is hidden from the model</li> <li><code>test</code>: data reserved for evaluation only; this data is completely hidden from the model and ourselves</li>",W,k,ge="The <code>validation</code> and <code>test</code> sets are especially important to ensure a model is actually learning instead of <em>overfitting</em>, or just memorizing the data.",Y,m,w,N,L,te,S,ve="Configurations",B,M,we='A <em>configuration</em> is a higher-level internal structure than a split, and a configuration contains splits. You can think of a configuration as a sub-dataset contained within a larger dataset. It is a useful structure for adding additional layers of organization to a dataset. For example, if you take a look at the <a href="https://huggingface.co/datasets/facebook/multilingual_librispeech" rel="nofollow">Multilingual LibriSpeech (MLS)</a> dataset, you’ll notice there are eight different languages. While you can create a dataset containing all eight languages, it’s probably neater to create a dataset with each language as a configuration. This way, users can instantly load a dataset with their language of interest instead of preprocessing the dataset to filter for a specific language.',D,P,_e='Configurations are flexible, and can be used to organize a dataset along whatever objective you’d like. For example, the <a href="https://huggingface.co/datasets/scene_parse_150" rel="nofollow">SceneParse150</a> dataset uses configurations to organize the dataset by task. One configuration is dedicated to segmenting the whole image, while the other configuration is for instance segmentation.',G,j,K;return _=new re({}),$=new re({}),L=new re({}),{c(){u=i("meta"),I=o(),E=i("p"),U=o(),f=i("h1"),g=i("a"),A=i("span"),ae(_.$$.fragment),Z=o(),T=i("span"),T.textContent=ce,q=o(),y=i("p"),y.innerHTML=de,F=o(),x=i("p"),x.innerHTML=ue,O=o(),p=i("h2"),v=i("a"),z=i("span"),ae($.$$.fragment),ee=o(),H=i("span"),H.textContent=fe,J=o(),b=i("p"),b.innerHTML=pe,R=o(),C=i("ul"),C.innerHTML=me,W=o(),k=i("p"),k.innerHTML=ge,Y=o(),m=i("h2"),w=i("a"),N=i("span"),ae(L.$$.fragment),te=o(),S=i("span"),S.textContent=ve,B=o(),M=i("p"),M.innerHTML=we,D=o(),P=i("p"),P.innerHTML=_e,G=o(),j=i("p"),this.h()},l(e){const a=Se("svelte-1phssyn",document.head);u=s(a,"META",{name:!0,content:!0}),a.forEach(t),I=l(e),E=s(e,"P",{}),c(E).forEach(t),U=l(e),f=s(e,"H1",{class:!0});var Q=c(f);g=s(Q,"A",{id:!0,class:!0,href:!0});var ye=c(g);A=s(ye,"SPAN",{});var xe=c(A);ne(_.$$.fragment,xe),xe.forEach(t),ye.forEach(t),Z=l(Q),T=s(Q,"SPAN",{"data-svelte-h":!0}),d(T)!=="svelte-1sauhb0"&&(T.textContent=ce),Q.forEach(t),q=l(e),y=s(e,"P",{"data-svelte-h":!0}),d(y)!=="svelte-rov9zo"&&(y.innerHTML=de),F=l(e),x=s(e,"P",{"data-svelte-h":!0}),d(x)!=="svelte-1p3cuco"&&(x.innerHTML=ue),O=l(e),p=s(e,"H2",{class:!0});var V=c(p);v=s(V,"A",{id:!0,class:!0,href:!0});var $e=c(v);z=s($e,"SPAN",{});var be=c(z);ne($.$$.fragment,be),be.forEach(t),$e.forEach(t),ee=l(V),H=s(V,"SPAN",{"data-svelte-h":!0}),d(H)!=="svelte-19t61ae"&&(H.textContent=fe),V.forEach(t),J=l(e),b=s(e,"P",{"data-svelte-h":!0}),d(b)!=="svelte-1xqui4b"&&(b.innerHTML=pe),R=l(e),C=s(e,"UL",{"data-svelte-h":!0}),d(C)!=="svelte-1ptk7op"&&(C.innerHTML=me),W=l(e),k=s(e,"P",{"data-svelte-h":!0}),d(k)!=="svelte-be0hj3"&&(k.innerHTML=ge),Y=l(e),m=s(e,"H2",{class:!0});var X=c(m);w=s(X,"A",{id:!0,class:!0,href:!0});var Ce=c(w);N=s(Ce,"SPAN",{});var ke=c(N);ne(L.$$.fragment,ke),ke.forEach(t),Ce.forEach(t),te=l(X),S=s(X,"SPAN",{"data-svelte-h":!0}),d(S)!=="svelte-1o4swfg"&&(S.textContent=ve),X.forEach(t),B=l(e),M=s(e,"P",{"data-svelte-h":!0}),d(M)!=="svelte-5g9nse"&&(M.innerHTML=we),D=l(e),P=s(e,"P",{"data-svelte-h":!0}),d(P)!=="svelte-3xxeom"&&(P.innerHTML=_e),G=l(e),j=s(e,"P",{}),c(j).forEach(t),this.h()},h(){r(u,"name","hf:doc:metadata"),r(u,"content",JSON.stringify(Ae)),r(g,"id","splits-and-configurations"),r(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(g,"href","#splits-and-configurations"),r(f,"class","relative group"),r(v,"id","splits"),r(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(v,"href","#splits"),r(p,"class","relative group"),r(w,"id","configurations"),r(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(w,"href","#configurations"),r(m,"class","relative group")},m(e,a){h(document.head,u),n(e,I,a),n(e,E,a),n(e,U,a),n(e,f,a),h(f,g),h(g,A),ie(_,A,null),h(f,Z),h(f,T),n(e,q,a),n(e,y,a),n(e,F,a),n(e,x,a),n(e,O,a),n(e,p,a),h(p,v),h(v,z),ie($,z,null),h(p,ee),h(p,H),n(e,J,a),n(e,b,a),n(e,R,a),n(e,C,a),n(e,W,a),n(e,k,a),n(e,Y,a),n(e,m,a),h(m,w),h(w,N),ie(L,N,null),h(m,te),h(m,S),n(e,B,a),n(e,M,a),n(e,D,a),n(e,P,a),n(e,G,a),n(e,j,a),K=!0},p:Me,i(e){K||(se(_.$$.fragment,e),se($.$$.fragment,e),se(L.$$.fragment,e),K=!0)},o(e){oe(_.$$.fragment,e),oe($.$$.fragment,e),oe(L.$$.fragment,e),K=!1},d(e){e&&(t(I),t(E),t(U),t(f),t(q),t(y),t(F),t(x),t(O),t(p),t(J),t(b),t(R),t(C),t(W),t(k),t(Y),t(m),t(B),t(M),t(D),t(P),t(G),t(j)),t(u),le(_),le($),le(L)}}}const Ae={local:"splits-and-configurations",sections:[{local:"splits",title:"Splits"},{local:"configurations",title:"Configurations"}],title:"Splits and configurations"};function ze(he){return Pe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ue extends Te{constructor(u){super(),He(this,u,ze,Ee,Le,{})}}export{Ue as component};
